commit a3871eead4540b3a746b877408088d41ce12c846
Author: Richard Biener <rguenther@suse.de>
Date:   Tue Jan 28 15:01:25 2025 +0100

    tree-optimization/112859 - add comment
    
    This adds a comment before the workaround, indicating flaky
    dependence analysis.
    
            PR tree-optimization/112859
            * tree-loop-distribution.cc
            (loop_distribution::pg_add_dependence_edges): Add comment.
    
    (cherry picked from commit 3ccbc8c9d182c380e396631b2b5a683de4fddba9)

diff --git a/gcc/tree-loop-distribution.cc b/gcc/tree-loop-distribution.cc
index aa5bd825c46..a1280a89880 100644
--- a/gcc/tree-loop-distribution.cc
+++ b/gcc/tree-loop-distribution.cc
@@ -2193,7 +2193,9 @@ loop_distribution::pg_add_dependence_edges (struct graph *rdg, int dir,
 		      this_dir = -this_dir;
 		    }
 		  /* When then dependence distance of the innermost common
-		     loop of the DRs is zero we have a conflict.  */
+		     loop of the DRs is zero we have a conflict.  This is
+		     due to wonky dependence analysis which sometimes
+		     ends up using a zero distance in place of unknown.  */
 		  auto l1 = gimple_bb (DR_STMT (dr1))->loop_father;
 		  auto l2 = gimple_bb (DR_STMT (dr2))->loop_father;
 		  int idx = index_in_loop_nest (find_common_loop (l1, l2)->num,

